﻿using System.Text.Json;
using System.Text.Json.Serialization;

var serializationOptions = new JsonSerializerOptions
{
    PropertyNameCaseInsensitive = true,
    NumberHandling = JsonNumberHandling.AllowReadingFromString
};

Console.WriteLine("Test 1 \nIn the JSON file the number for \"Age\" is represented as a string -- \"Age\": \"25\"");

string textInFile1 = File.ReadAllText("PersonWithNumberAsString.json");
Person person1 = JsonSerializer.Deserialize<Person>(textInFile1, serializationOptions);
Console.WriteLine($"When I used the serialization options, I got - {person1.FirstName} {person1.LastName}, aged {person1.Age}.");

try
{
    person1 = JsonSerializer.Deserialize<Person>(textInFile1);
}
catch (JsonException ex)
{
    Console.WriteLine($"When I did not use the JsonSerializerOptions, I got an exception - {ex.Message}.");
    Console.WriteLine("This happened because \"Age\" was a string instead of a number.");
}


Console.WriteLine("\n\n\nTest 2 \nIn the JSON file \"LastName\", is the only one that matches a property in the Person class.");
string textInFile2 = File.ReadAllText("PersonWithCasingThatDoesntMatchClassProperties.json");

Person person2 = JsonSerializer.Deserialize<Person>(textInFile2, serializationOptions);
Console.WriteLine($"When I used the serialization options, I got - {person2.FirstName} {person2.LastName}, aged {person2.Age}.");

person2 = JsonSerializer.Deserialize<Person>(textInFile2);
Console.WriteLine($"When I didn't use the serialization options, I got - {person2.FirstName} {person2.LastName}, aged {person2.Age}.  \"firstName\" and \"age\" are missing, \"LastName\" was the only property that matched the JSON file.");


